(setq gc-cons-threshold most-positive-fixnum)
;; install straight.el
(defvar bootstrap-version)
(let ((bootstrap-file
       (expand-file-name "straight/repos/straight.el/bootstrap.el" user-emacs-directory))
      (bootstrap-version 5))
  (unless (file-exists-p bootstrap-file)
    (with-current-buffer
        (url-retrieve-synchronously
         "https://raw.githubusercontent.com/raxod502/straight.el/develop/install.el"
         'silent 'inhibit-cookies)
      (goto-char (point-max))
      (eval-print-last-sexp)))
  (load bootstrap-file nil 'nomessage))

;; load own config files
(setq custom-file (concat user-emacs-directory "customs.el"))
(unless (file-exists-p custom-file)
    (make-empty-file custom-file))
(load-file custom-file)

(push (concat user-emacs-directory "cnf") load-path)

(require 'essentials)
(require 'ui)
(require 'additionals)
(require 'global-keybindings)
(require 'functions)
(require 'programming)

;; set gc values back to smth reasonable
(setq gc-cons-threshold 104857600) ;; 100 MegaByte (LSP)
